
--[[
	gnome dust

	enchanting mod of complete uselessness
]]



GnomeDust = {}


function GnomeDust:Dust_OnUpdate(p,elapsed)
	local cd = .7 + p.mass * .25

	local drag = math.pow(cd, 1+elapsed)

	p.x = p.x + p.vx * elapsed
	p.y = p.y + p.vy * elapsed

	p.life = p.life - elapsed


	p.vx = p.vx * drag
	p.vy = p.vy * drag - math.pow(10, 1+elapsed)

	if p.life < 0 then
		p:Hide()
		self.dustInactive[p.id] = p
		self.dustActive[p.id] = nil
	else
		p:SetPoint("CENTER",UIParent,"BOTTOMLEFT",p.x, p.y)

		if mod(p.life, p.period) < p.ratio then
			p:SetWidth(p.size*1.5)
			p:SetHeight(p.size*1.5)
			p:SetVertexColor(p.r+.5, p.g+.5, p.b+.5)
		else
			p:SetWidth(p.size*self.dustSize)
			p:SetHeight(p.size*self.dustSize)
			p:SetVertexColor(p.r, p.g, p.b)
		end

	end
end




function GnomeDust:Core_OnUpdate(p,elapsed)

	p.life = p.life - elapsed * self.coreLength

	if p.life < 0 then
		p:Hide()
		self.coreInactive[p.id] = p
		self.coreActive[p.id] = nil
	else
		local b = p.life/.5
		local b2 = math.pow(b,2)

		p:SetPoint("CENTER",UIParent,"BOTTOMLEFT",p.x, p.y)

		p:SetWidth(p.size*self.coreSize*(1+b2))
		p:SetHeight(p.size*self.coreSize*(1+b2))
		p:SetVertexColor(b*self.coreColorR, b*self.coreColorG,b*self. coreColorB)
	end
end


function GnomeDust:DustCreate(ox, oy, x, y, elapsed)
	local dx = x-ox
	local dy = y-oy

	local sparkRate = 0.05 * (1 + self.dustSparkRate)

	local particles = (elapsed + math.pow(dx*dx+dy*dy,.5)*.05) * self.dustSpawnRate

	for id,p in pairs(self.dustInactive) do
		local u = math.random()

		local nx = ox + dx * u
		local ny = oy + dy * u


		p:SetPoint("CENTER",UIParent,"BOTTOMLEFT",nx,ny)

		local d = random()*360
		local v = random()

		if random()<sparkRate then
			v = v * (1+random()*5)
		end

		p.life = random()+.5

		p.vx = dx + sin(d)*math.pow(v,.5)*200
		p.vy = dy + cos(d)*math.pow(v,.5)*200

		p.x = nx
		p.y = ny


		p:Show()

		self.dustActive[id] = p
		self.dustInactive[id] = nil

		particles = particles - 1

		if particles < 1 then
			break
		end
	end

-- re-use active particles that (hopefully) are older and might go un-missed should they vanish
	if particles > 0 then
		for id,p in pairs(self.dustActive) do
			local u = math.random()

			local nx = ox + dx * u
			local ny = oy + dy * u

			p:SetPoint("CENTER",UIParent,"BOTTOMLEFT",nx,ny)

			local d = random()*360
			local v = random()

			if random()<.05 then
				v = v * (1+random()*5)
			end

			p.vx = dx + sin(d)*math.pow(v,.5)*200
			p.vy = dy + cos(d)*math.pow(v,.5)*200

			p.x = nx
			p.y = ny

			p.life = random()+.5

			p:Show()

			particles = particles - 1

			if particles < 1 then
				break
			end
		end
	end
end



function GnomeDust:CoreCreate(px0,py0, px1,py1, x2,y2, x3, y3, elapsed)
	local x0, y0 = px1,py1
	local x1, y1 = (px1-px0) + px1, (py1-py0) + py1

	local len0 = math.pow((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0),.5)
	local len1 = math.pow((x2-x2)*(x2-x1)+(y2-y1)*(y2-y1),.5)
	local len2 = math.pow((x3-x2)*(x3-x2)+(y3-y2)*(y3-y2),.5)

	local particles = (len0+len1+len2)/(self.coreSize/5) + self.coreFraction

	self.coreFraction = mod(particles,1)

	if particles > 5000 then particles = 5000 end			-- failsafe to prevent too many particles


	local i = particles

	if i > 0 then
		local ox = x3
		local oy = y3

		for id,p in pairs(self.coreInactive) do
			local u = (i/particles)
			local iu = 1-u

			local nx0 = iu * x1 + u * x0
			local ny0 = iu * y1 + u * y0

			local nx1 = iu * x2 + u * x1
			local ny1 = iu * y2 + u * y1

			local nx2 = iu * x3 + u * x2
			local ny2 = iu * y3 + u * y2


			local nxA = iu * nx1 + u * nx0
			local nyA = iu * ny1 + u * ny0

			local nxB = iu * nx2 + u * nx1
			local nyB = iu * ny2 + u * ny1


			local nx = iu * nxB + u * nxA
			local ny = iu * nyB + u * nyA

			p.x = nx
			p.y = ny

			p.life = .5 - u * elapsed
			p.size = random()*.5+.5

			p:Show()

			self.coreActive[id] = p
			self.coreInactive[id] = nil

			i = i - 1

			if i<0 then
				break
			end
		end
	end


	if i > 0 then
		local numCore = #self.coreActive

		for n=1,i do
			local id = numCore + n

			local p = self.parentFrame:CreateTexture(nil,"BACKGROUND")
			p:SetTexture("Interface\\Addons\\GnomeDust\\puff.tga")
			p:SetBlendMode("ADD")

			p.id = id


			local u = (i/particles)
			local iu = 1-u

			local nx0 = iu * x1 + u * x0
			local ny0 = iu * y1 + u * y0

			local nx1 = iu * x2 + u * x1
			local ny1 = iu * y2 + u * y1

			local nx2 = iu * x3 + u * x2
			local ny2 = iu * y3 + u * y2


			local nxA = iu * nx1 + u * nx0
			local nyA = iu * ny1 + u * ny0

			local nxB = iu * nx2 + u * nx1
			local nyB = iu * ny2 + u * ny1


			local nx = iu * nxB + u * nxA
			local ny = iu * nyB + u * nyA


			p.x = nx
			p.y = ny

			p.life = .5 - u * elapsed
			p.size = random()*.5+.5

			p:Show()

			self.coreActive[id] = p
		end
	end

end


function GnomeDust:ParentFrame_OnUpdate(elapsed)
	self.perSecond = self.perSecond + 1
	self.elapsedTime = self.elapsedTime + elapsed

	local scale = self.parentFrame:GetEffectiveScale()

	local x, y = GetCursorPosition()
	x = x / scale
	y = y / scale


	self.bumpTime = (self.bumpTime or 0) - elapsed

	if self.bumpTime < 0 then
		self.bumpTime = random()*.1

		self.pinx = x + random()*10-5
		self.piny = y + random()*10-5
	end


	if not self.x then
		self.x = self.pinx+random()-0.5
		self.y = self.piny+random()-0.5
	end


	if self.enchanting then
		if not SpellIsTargeting() then
			self.spawn = false
			self.enchanting = false
		end
	end



	local dx = self.pinx - self.x
	local dy = self.piny - self.y

	local d = math.pow(dx*dx+dy*dy, .5)

	dx = dx / (d+0.001)
	dy = dy / (d+0.001)

	local s = math.pow(d, .8) * 20

	if s < 2 then
		s = 2
	end

	self.vx = self.vx + dx*s
	self.vy = self.vy + dy*s

	self.x = self.x + self.vx*elapsed
	self.y = self.y + self.vy*elapsed


	local cd = 1 - (d)*.02

	if cd > .9 then cd = .9 end
	if cd < 0 then cd = 0 end

	local drag = math.pow(cd, 1+elapsed)

	self.vx = self.vx * drag
	self.vy = self.vy * drag


	local mx, my = x, y

	if self.spawn then
		self:DustCreate(self.ox, self.oy, self.x, self.y, elapsed)


		if self.drawCurve then
			self:CoreCreate(self.x0,self.y0,  self.x1,self.y1,  self.x2,self.y2,  self.x,self.y, elapsed)
			self.drawCurve = false
		else
			self.drawCurve = true
		end


		self.puff:Show()

		local size = math.pow(math.random(),3)*30+40

		local r = math.sin(self.elapsedTime*360)*.5+math.sin(self.elapsedTime*777)*.25+.5
		local g = math.sin(self.elapsedTime*360)*.5+math.cos(self.elapsedTime*777)*.25+.5
		local b = math.cos(self.elapsedTime*360)*.5+math.sin(self.elapsedTime*777)*.25+.5

		self.puff:SetPoint("CENTER",UIParent,"BOTTOMLEFT", self.x,self.y)
		self.puff:SetWidth(size)
		self.puff:SetHeight(size)

		self.puff:SetVertexColor(r*.3,g*.3,b*.3)



		local d = (sin(self.elapsedTime*190)+sin(self.elapsedTime*380)*.5)*360
		local v = cos(self.elapsedTime*17)*.75+cos(self.elapsedTime*27)*.25

		self.vx = self.vx + sin(d)*v*200
		self.vy = self.vy + cos(d)*v*200


	else
		self.puff:Hide()
	end

	self.x0, self.y0 = self.x1, self.y1
	self.x1, self.y1 = self.x2, self.y2
	self.x2, self.y2 = self.x, self.y

	self.ox = self.x
	self.oy = self.y
	self.numDust = 0

	for id, p in pairs(self.dustActive) do
		GnomeDust:Dust_OnUpdate(p,elapsed)

		self.numDust = self.numDust + 1
	end

	for id, c in pairs(self.coreActive) do
		GnomeDust:Core_OnUpdate(c,elapsed)
	end
end



local function GetID(link)
	if (link) then
		local found, _, string = string.find(link, "^|c%x+|H(.+)|h%[.+%]")

		if found then
			local _, id = strsplit(":", string)

			return tonumber(id);
		else
			return nil
		end
	end
end


function GnomeDust:CoreColorFromTrade(index)
	if index then
		local recipeLink = GetTradeSkillRecipeLink(index)
		local id = GetID(recipeLink)

		code = mod(id*117, 360)
	else
		code = random(360)
	end


	local r = sin(code    )*.5+.75
	local g = sin(code+120)*.5+.75
	local b = sin(code+240)*.5+.75


	return r, g, b
end



function GnomeDust:CoreSizeFromTrade(index)
	if index then
		local numReagents = GetTradeSkillNumReagents(index)

		return math.pow(numReagents,.5)*3.5
	else
		return random(3,7)
	end
end


function GnomeDust:DustSpawnRateFromTrade(index)
	if index then
		local numReagents = GetTradeSkillNumReagents(index)

		local dustCount = 0
		local shardCount = 0
		local essenceCount = 0
		local primalCount = 0
		local miscCount = 0

		for i=1,numReagents do
			local reagentName, icon, needed = GetTradeSkillReagentInfo(index,i)

			if string.find(reagentName, "Dust") then
				dustCount = dustCount + needed
			elseif string.find(reagentName, "Shard") then
				shardCount = shardCount + needed
			elseif string.find(reagentName, "Essence") then
				essenceCount = essenceCount + needed
			elseif string.find(reagentName, "Primal") then
				primalCount = primalCount + needed
			else
				miscCount = miscCount + needed
			end
		end


		local rate = math.pow(dustCount * 10 + shardCount + essenceCount * 3 + primalCount * 2 + miscCount + 6, .6)

--		DEFAULT_CHAT_FRAME:AddMessage(rate)
		return rate, primalCount
	else
		if random() < .1 then
			return random(8,12), random(8)
		else
			return random(8,12), 0
		end
	end

end



function GnomeDust:InitSpawn(index)

-- for testing purposes just grab a random craft to quickly play with different setting variations
--[[
	local x

	repeat
		index = random(1, GetNumCrafts())
		_, x = GetCraftInfo(index)
	until x ~= "Header"
]]
--	local name = GetCraftInfo(index)

--	DEFAULT_CHAT_FRAME:AddMessage(name or "nil")

	self.coreColorR, self.coreColorG, self.coreColorB = self:CoreColorFromTrade(index)
	self.coreSize = self:CoreSizeFromTrade(index)
	self.coreLength = 5 / self.coreSize


	self.dustSpawnRate, self.dustSparkRate = self:DustSpawnRateFromTrade(index)
	self.dustSize = math.pow(8 / self.dustSpawnRate,.8)

	self.spawn = true

	self.x = nil
	self.y = nil

	self.initTime = GetTime()
end


function GnomeDust:Release()
	self.spawn = false
end




local function DoTradeSkillHook(index)
	if SpellIsTargeting() then
		GnomeDust:InitSpawn(index)
		GnomeDust.enchanting = true
	end
end


function GnomeDust:Initialize()
	math.randomseed(math.random(0,2147483647)+(GetTime()*1000))

	self.parentFrame = CreateFrame("Frame", "GnomeDustParentFrame", UIParent)

	self.parentFrame:SetFrameStrata("TOOLTIP")
	self.numDust = 0
	self.maxDust = 2000
	self.maxCore = 2000
	self.dustID = 1
	self.dustActive = {}
	self.dustInactive = {}

	self.coreActive = {}
	self.coreInactive = {}

	self.perSecond = 0
	self.elapsedTime = 0

	self.coreFraction = 0
	self.dustFraction = 0

	self.initTime = 0

	self.vx = 0
	self.vy = 0

	for i=1,self.maxDust do
		local p = self.parentFrame:CreateTexture(nil,"BACKGROUND")
		p:SetTexture("Interface\\Addons\\GnomeDust\\particle.tga")
		p:SetBlendMode("ADD")

		local size = random()*3+1

		p.ratio = .1*random()+.05
		p.period = .5+random()
		p.size = size

		p.life = random()+.5
		p.mass = random()*.5+.5


		p:SetWidth(size)
		p:SetHeight(size)

		local r,g,b = random()+.5, random()+.5, random()+.5

		local l = math.pow(r*r+b*b+g*g,.5)

		p.r = r/l
		p.g = g/l
		p.b = b/l


		p.id = i

		self.dustInactive[i] = p
	end


	for i=1,self.maxCore do
		local c = self.parentFrame:CreateTexture(nil,"BACKGROUND")
		c:SetTexture("Interface\\Addons\\GnomeDust\\puff.tga")
		c:SetBlendMode("ADD")

		c.id = i

		self.coreInactive[i] = c
	end

	local puff = self.parentFrame:CreateTexture(nil,"BACKGROUND")
	puff:SetTexture("Interface\\Addons\\GnomeDust\\puff.tga")
	puff:SetBlendMode("ADD")
	puff:Hide()

	self.puff = puff

	self.parentFrame:SetScript("OnUpdate", function() GnomeDust:ParentFrame_OnUpdate(arg1) end)

	hooksecurefunc("DoTradeSkill", DoTradeSkillHook)



	self.parentFrame:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	self.parentFrame:RegisterEvent("CHAT_MSG_YELL")


	self.parentFrame:SetScript("OnEvent", function() GnomeDust:ParentFrame_OnEvent(event,arg1,arg2) end)

end


local emoteKey = 1
function GnomeDust:ParentFrame_OnEvent(event,arg1,arg2)
	local emoteList = {"You burst into dance.", "You bow down graciously.", "You cheer!"}

	if event == "CHAT_MSG_TEXT_EMOTE" then
--		DEFAULT_CHAT_FRAME:AddMessage("text emote "..arg1)
		if arg1 == emoteList[emoteKey] then

--[[
			if emoteKey == #emoteList then
				self:InitSpawn()
				self.emoted = true

				emoteKey = 1
			else
				emoteKey = emoteKey + 1
			end
]]
			emoteKey = emoteKey + 1
		else
			emoteKey = 1

--			self:Release()
		end
	end

	if event == "CHAT_MSG_YELL" then
		if arg2 == UnitName("player") then
			local t = string.lower(arg1)

			if string.find(t,"summon") and string.find(t,"enchanting") and string.find(t,"fairy") then
				if emoteKey > #emoteList then
					self.summoned = true
					self:InitSpawn()
				else
					emoteKey = 1
					self:Release()
				end
			else
				emoteKey = 1
				self:Release()
			end

		end
	end
end



GnomeDust:Initialize()
